package com.huimv.eartag2.manage2.service.impl;

import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.eartag2.manage2.mapper.EartagDeviceRegisterMapper;
import com.huimv.eartag2.manage2.pojo.EartagAbnormalAlarm;
import com.huimv.eartag2.manage2.pojo.EartagAbnormalCount;
import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.common.utils.ResultCode;
import com.huimv.eartag2.manage2.mapper.EartagAbnormalAlarmMapper;
import com.huimv.eartag2.manage2.mapper.EartagAbnormalCountMapper;
import com.huimv.eartag2.manage2.pojo.EartagDeviceRegister;
import com.huimv.eartag2.manage2.service.EartagAbnormalCountService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zn
 * @since 2022-08-20
 */
@Service
public class EartagAbnormalCountServiceImpl extends ServiceImpl<EartagAbnormalCountMapper, EartagAbnormalCount> implements EartagAbnormalCountService {
    @Autowired
    private EartagAbnormalCountMapper eartagAbnormalCountMapper;
    @Autowired
    private EartagAbnormalAlarmMapper eartagAbnormalAlarmMapper;
    @Autowired
    private EartagDeviceRegisterMapper registerMapper;

    @Override
    public Result listAbnormalCount(Map<String, String> map) {
        String farmCode = map.get("farmId")+"";
        String addDate = map.get("addDate")+"";
        QueryWrapper<EartagAbnormalCount> wrapper = new QueryWrapper();
        wrapper.eq("farm_code",farmCode).eq("add_date",addDate);
        EartagAbnormalCount eartagAbnormalCount = eartagAbnormalCountMapper.selectOne(wrapper);
        return new Result(ResultCode.SUCCESS,eartagAbnormalCount);
    }

    @Override
    public Result listAbnoramAll(Map<String, String> map) {
        String farmId = map.get("farmId");
        String pageNo = map.get("pageNo");
        String pageSize = map.get("pageSize");
        QueryWrapper<EartagAbnormalAlarm> wrapper = new QueryWrapper<>();
        wrapper.eq("alarm_from",2);
        wrapper.ge("add_time", DateUtil.beginOfDay(new Date()));
        wrapper.eq("farm_code",farmId);
        wrapper.orderByDesc("id");
        Page<EartagAbnormalAlarm> eartagAbnormalAlarmPage = eartagAbnormalAlarmMapper.selectPage(
                new Page<EartagAbnormalAlarm>(Long.parseLong(pageNo), Long.parseLong(pageSize)), wrapper);

        JSONObject jsonObject = new JSONObject();
        wrapper.eq("alarm_type", 2);
        List<EartagAbnormalAlarm> alarms = eartagAbnormalAlarmMapper.selectList(wrapper);

        QueryWrapper<EartagAbnormalAlarm> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("alarm_from",2);
        queryWrapper.ge("add_time", DateUtil.beginOfDay(new Date()));
        queryWrapper.eq("farm_code",farmId);
        queryWrapper.eq("alarm_type", 1);
        List<EartagAbnormalAlarm> alarms1 = eartagAbnormalAlarmMapper.selectList(queryWrapper);
        jsonObject.put("dataCount", alarms.size());
        jsonObject.put("statusCount", alarms1.size());

        return  new Result(ResultCode.SUCCESS,eartagAbnormalAlarmPage,jsonObject);
    }

    @Override
    public Result listAbnoramDev(Map<String, String> map) {
        String farmId = map.get("farmId");
        String pageNo = map.get("pageNo");
        String pageSize = map.get("pageSize");
        QueryWrapper<EartagAbnormalAlarm> wrapper = new QueryWrapper<>();
        wrapper.eq("alarm_from",1);
        wrapper.ge("add_time", DateUtil.beginOfDay(new Date()));
        wrapper.eq("farm_code",farmId);
        wrapper.orderByDesc("id");
        Page<EartagAbnormalAlarm> eartagAbnormalAlarmPage = eartagAbnormalAlarmMapper.selectPage(
                new Page<EartagAbnormalAlarm>(Long.parseLong(pageNo), Long.parseLong(pageSize)), wrapper);


        JSONObject jsonObject = new JSONObject();
        QueryWrapper<EartagDeviceRegister> queryWrapper1 = new QueryWrapper<>();
        queryWrapper1.eq("farm_id", farmId).eq("device_status",0);
        List<EartagDeviceRegister> registerList = registerMapper.selectList(queryWrapper1);

        wrapper.eq("alarm_type", 2);
        List<EartagAbnormalAlarm> alarms = eartagAbnormalAlarmMapper.selectList(wrapper);

//        QueryWrapper<EartagAbnormalAlarm> queryWrapper = new QueryWrapper<>();
//        queryWrapper.eq("alarm_from",1);
//        queryWrapper.ge("add_time", DateUtil.beginOfDay(new Date()));
//        queryWrapper.eq("farm_code",farmId);
//        queryWrapper.eq("alarm_type", 1);
//        List<EartagAbnormalAlarm> alarms1 = eartagAbnormalAlarmMapper.selectList(queryWrapper);
        jsonObject.put("dataCount", alarms.size());
        jsonObject.put("statusCount", registerList.size());
        return new Result(ResultCode.SUCCESS, eartagAbnormalAlarmPage, jsonObject);
    }
    @Override
    public Result listAbnoramAll1(Map<String, String> map) {
        String farmId = map.get("farmId");
        String pageNo = map.get("pageNo");
        String pageSize = map.get("pageSize");
        QueryWrapper<EartagAbnormalAlarm> wrapper = new QueryWrapper<>();
        wrapper.eq("alarm_from",2);
        wrapper.eq("farm_code",farmId);
        wrapper.orderByDesc("id");
        Page<EartagAbnormalAlarm> eartagAbnormalAlarmPage = eartagAbnormalAlarmMapper.selectPage(
                new Page<EartagAbnormalAlarm>(Long.parseLong(pageNo), Long.parseLong(pageSize)), wrapper);

        JSONObject jsonObject = new JSONObject();
        wrapper.eq("alarm_type", 2);
        List<EartagAbnormalAlarm> alarms = eartagAbnormalAlarmMapper.selectList(wrapper);

        QueryWrapper<EartagAbnormalAlarm> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("alarm_from",2);
        queryWrapper.ge("add_time", DateUtil.beginOfDay(new Date()));
        queryWrapper.eq("farm_code",farmId);
        queryWrapper.eq("alarm_type", 1);
        List<EartagAbnormalAlarm> alarms1 = eartagAbnormalAlarmMapper.selectList(queryWrapper);
        jsonObject.put("dataCount", alarms.size());
        jsonObject.put("statusCount", alarms1.size());

        return  new Result(ResultCode.SUCCESS,eartagAbnormalAlarmPage,jsonObject);
    }

    @Override
    public Result listAbnoramDev1(Map<String, String> map) {
        String farmId = map.get("farmId");
        String pageNo = map.get("pageNo");
        String pageSize = map.get("pageSize");
        QueryWrapper<EartagAbnormalAlarm> wrapper = new QueryWrapper<>();
        wrapper.eq("alarm_from",1);
        wrapper.eq("farm_code",farmId);
        wrapper.orderByDesc("id");
        Page<EartagAbnormalAlarm> eartagAbnormalAlarmPage = eartagAbnormalAlarmMapper.selectPage(
                new Page<EartagAbnormalAlarm>(Long.parseLong(pageNo), Long.parseLong(pageSize)), wrapper);


        JSONObject jsonObject = new JSONObject();
        QueryWrapper<EartagDeviceRegister> queryWrapper1 = new QueryWrapper<>();
        queryWrapper1.eq("farm_id", farmId).eq("device_status",0);
        List<EartagDeviceRegister> registerList = registerMapper.selectList(queryWrapper1);

        wrapper.eq("alarm_type", 2);
        List<EartagAbnormalAlarm> alarms = eartagAbnormalAlarmMapper.selectList(wrapper);

//        QueryWrapper<EartagAbnormalAlarm> queryWrapper = new QueryWrapper<>();
//        queryWrapper.eq("alarm_from",1);
//        queryWrapper.ge("add_time", DateUtil.beginOfDay(new Date()));
//        queryWrapper.eq("farm_code",farmId);
//        queryWrapper.eq("alarm_type", 1);
//        List<EartagAbnormalAlarm> alarms1 = eartagAbnormalAlarmMapper.selectList(queryWrapper);
        jsonObject.put("dataCount", alarms.size());
        jsonObject.put("statusCount", registerList.size());
        return new Result(ResultCode.SUCCESS, eartagAbnormalAlarmPage, jsonObject);
    }
}
